﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections;
using Infragistics.Controls.Grids;
using Infragistics.Controls;
using System.Windows.Markup;

namespace CheckAllHeaderSample1
{
   public partial class MainPage : UserControl
   {
      public MainPage()
      {
         InitializeComponent();
         BindTheGrid();
      }

      /// <summary>
      /// Bind the grid
      /// </summary>

      public void BindTheGrid()
      {


         List<string> oColNames;
         IList oRecords = ReadSampleData.GenerateTestData(out oColNames);

         //foreach (List<string> oList in oRecords)
         //{
         //   oList.Insert(0, "N");
         //}

         //oColNames.Insert(0, c_sDeleteColumn);



         for (int i = 0; i < oColNames.Count; i++)
         {
            if (i == 0)
               AddCheckBoxColumn("[0]");
            else
               AddTextColumn(oColNames[i], "[" + i + "]");
         }


         m_wGrid.AutoGenerateColumns = false;
         m_wGrid.ItemsSource = oRecords;
         
      }

      void AddTextColumn(string sHeaderText, string sKey)
      {
         TextColumn oTextCol = new TextColumn();
         oTextCol.HeaderText = sHeaderText;
         oTextCol.Key = sKey;
         
         m_wGrid.Columns.Add(oTextCol);
                  
      }
      
      void AddCheckBoxColumn(string sKey)
      {
         CheckBoxColumn oCheckBoxCol = new CheckBoxColumn();         
         oCheckBoxCol.Key = sKey;

         oCheckBoxCol.HeaderTemplate = CreateCheckBoxTemplate();         
         m_wGrid.Columns.Add(oCheckBoxCol);
      }


      DataTemplate CreateCheckBoxTemplate()
      {

         // TODO: only fires the last command

         return (DataTemplate)XamlReader.Load(
                 @"<DataTemplate
                     xmlns=""http://schemas.microsoft.com/client/2007""
                     xmlns:ig=""http://schemas.infragistics.com/xaml""
                     xmlns:local=""clr-namespace:CheckAllHeaderSample1;assembly=CheckAllHeaderSample1"">

                     <CheckBox >        
                              <ig:Commanding.Command>

                                    <local:MyCommandSourceUnchecked EventName=""Unchecked""></local:MyCommandSourceUnchecked>

                                    <local:MyCommandSourceChecked EventName=""Checked""></local:MyCommandSourceChecked>                                    

                                </ig:Commanding.Command>                
                     </CheckBox>

            </DataTemplate>"
          );
      }


   }



   public class MyCommandSourceChecked : CommandSource
   {

      protected override ICommand ResolveCommand()
      {
         return new CheckedCommand();
      }
   }

   public class MyCommandSourceUnchecked : CommandSource
   {
      protected override ICommand ResolveCommand()
      {
         return new UncheckedCommand();
      }

   }

   public class CheckedCommand : ColumnCommandBase
   {
      /// <summary>
      /// Check all 
      /// </summary>
      /// <param name="col"></param>

      protected override void ExecuteCommand(Column col)
      {



      }

   }

   public class UncheckedCommand : ColumnCommandBase
   {

      protected override void ExecuteCommand(Column col)
      {

         // perform logic: 

      }

   }
}
